#ifndef FLE_LISTITEM_H
#define FLE_LISTITEM_H

#include <fltk/Fl.h>
#include <fltk/Fl_Widget.h>
#include <fltk/fl_draw.h>
#include <fltk/Fl_Image.h>

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "FLE_ListView.h"

#define MAX_COLS 10
#define OLISTITEM 0x06660000

class FLE_ListItem : public Fl_Widget {
public: 
	FLE_ListItem();
	FLE_ListItem(const char *label1,
               const char *label2=0,
               const char *label3=0,
               const char *label4=0,
               const char *label5=0);
  ~FLE_ListItem();

 	FLE_ListView *listview() { return list; }
	void draw();	
	void draw_cell(int x, int y, int w, int h, int col);
	void layout();
	
	int width(int col) { return widths[col]; }

  void copy_label(int col, const char *txt);

  Fl_Flags col_flags(int col, int f) { return colflags[col] = f; }
  Fl_Flags col_flags(int col) { return colflags[col]; }
  Fl_Flags col_set_flag(int col, int f)	{return colflags[col] |= f;}
  Fl_Flags col_clear_flag(int col, int f)	{return colflags[col] &= ~f;}
  Fl_Flags col_invert_flag(int col, int f)	{return colflags[col] ^= f;}

	const char *label() { return label(0); }
	const char *label(int col) { return labels[col]; }
  void label(int col, const char *text) { labels[col] = text; }

	Fl_Font font(int col, int *size) { if(size) *size = font_sizes[col]; return fonts[col]; }
	void font(int col, Fl_Font font, int size) { fonts[col] = font; font_sizes[col] = size; }
	void color(int col, Fl_Color color) { colors[col] = color; }

	void image(int col, Fl_Image *im) { images[col] = im; }
	Fl_Image *image(int col) { return images[col]; }

	static char *get_multiline(const char *buf, int maxwidth);

	int num;

private:
	FLE_ListView *list;
	
	const char *labels[MAX_COLS];
	int widths[MAX_COLS];
	
	Fl_Font fonts[MAX_COLS];
	int font_sizes[MAX_COLS];

  int colflags[MAX_COLS];
	
	Fl_Color colors[MAX_COLS];

	Fl_Image *images[MAX_COLS];
};

#endif
